#!/bin/sh

cd /root

/bin/ipfs-key "$@" 2> /root/keygen.stderr 1> captain-cluster.key
awk '/^ID for generated key:/ {print $5}' < keygen.stderr > captain-cluster.id
rm /root/keygen.stderr

/bin/ipfs-key "$@" 2> /root/keygen.stderr 1> commander-cluster.key
awk '/^ID for generated key:/ {print $5}' < keygen.stderr > commander-cluster.id
rm /root/keygen.stderr

/bin/ipfs-key "$@" 2> /root/keygen.stderr 1> captain-ipfs.key
awk '/^ID for generated key:/ {print $5}' < keygen.stderr > captain-ipfs.id
rm /root/keygen.stderr

/bin/ipfs-key "$@" 2> /root/keygen.stderr 1> commander-ipfs.key
awk '/^ID for generated key:/ {print $5}' < keygen.stderr > commander-ipfs.id
rm /root/keygen.stderr

xxd -p -l 32 -c 32 /dev/random | tr -d '\n' > cluster.key

cat << EOF
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: ipfs-config
data:
  captain-cluster-id: |-
    $(cat captain-cluster.id)
  commander-cluster-id: |-
    $(cat commander-cluster.id)
  captain-ipfs-id: |-
    $(cat captain-ipfs.id)
  commander-ipfs-id: |-
    $(cat commander-ipfs.id)
---
apiVersion: v1
kind: Secret
metadata:
  name: ipfs-secrets
stringData:
  cluster-secret: |-
    $(xxd -p -l 32 -c 32 /dev/random)
  captain-cluster-key: |-
    $(base64 -w 0 captain-cluster.key)
  commander-cluster-key: |-
    $(base64 -w 0 commander-cluster.key)
  captain-ipfs-key: |-
    $(base64 -w 0 captain-ipfs.key)
  commander-ipfs-key: |-
    $(base64 -w 0 commander-ipfs.key)
EOF
